// #autoload
// #name = ssScoreHudT2
// #category = ilys' Scripts
$ssScoreHudInterval = 1;
$ssScoreHudShowReturner = false;

function ssScoreHudHandleFlag(%msgType, %msgString, %clientName, %flagTeam, %flagTeamId) {
    if ($ssScoreHudTeamId != 1 && $ssScoreHudTeamId != 2)
        return;
    %msgType = detag(%msgType);
    %clientName = detag(%clientName);
    %flagTeamId = detag(%flagTeamId);
    switch$(%msgType) {
        case "MsgCTFFlagTaken":
            if (%flagTeamId == $ssScoreHudTeamId) {
                if (isEventPending($ssScoreHudFriendlySchedule))
                    cancel($ssScoreHudFriendlySchedule);
                SSFriendlyScoreHud.setBitmap("ssflag_friendly_taken.png");
                SSFriendlyScoreHudText.setText("Taken");
            } else {
                if (isEventPending($ssScoreHudEnemySchedule))
                    cancel($ssScoreHudEnemySchedule);
                SSEnemyScoreHud.setBitmap("ssflag_enemy_taken.png");
                SSEnemyScoreHudText.setText("Taken");
            }
            commandToServer('getScores');
        case "MsgCTFFlagDropped":
            if (%flagTeamId == $ssScoreHudTeamId) {
                SSFriendlyScoreHud.setBitmap("ssflag_friendly_taken.png");
                ssScoreHudFriendlyTimer(true);
            } else {
                SSEnemyScoreHud.setBitmap("ssflag_enemy_taken.png");
                ssScoreHudEnemyTimer(true);
            }
        case "MsgCTFFlagReturned":
            if (%flagTeamId == $ssScoreHudTeamId) {
                if (isEventPending($ssScoreHudFriendlySchedule))
                    cancel($ssScoreHudFriendlySchedule);
                SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
                if ($ssScoreHudShowReturner) {
                    SSFriendlyScoreHudText.setText("\c7\xab " @ %clientName);
                    SSFriendlyScoreHudText.schedule(3000, setText, "Home");
                } else
                    SSFriendlyScoreHudText.setText("Home");
            } else {
                if (isEventPending($ssScoreHudEnemySchedule))
                    cancel($ssScoreHudEnemySchedule);
                SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
                if ($ssScoreHudShowReturner) {
                    SSEnemyScoreHudText.setText("\c7\xab " @ %clientName);
                    SSEnemyScoreHudText.schedule(3000, setText, "Home");
                } else
                    SSEnemyScoreHudText.setText("Home");
            }
        case "MsgCTFFlagCapped":
            if (%flagTeamId == $ssScoreHudTeamId) {
                SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
                SSFriendlyScoreHudText.setText("Home");
            } else {
                SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
                SSEnemyScoreHudText.setText("Home");
            }
            commandToServer('getScores');
    }
    ssScoreHudDrawScores();
}

function ssScoreHudHandleScore(%msgType, %msgString, %teamId, %teamScore) {
    if ($ssScoreHudTeamId $= "")
        $ssScoreHudTeamId = "0";
    if (%teamId == $ssScoreHudTeamId)
        $ssScoreHudFriendlyScore = %teamScore;
    else
        $ssScoreHudEnemyScore = %teamScore;
    ssScoreHudDrawScores();
}

function ssScoreHudDrawScores() {
    SSFriendlyScoreHudScore.setText($ssScoreHudFriendlyScore);
    SSEnemyScoreHudScore.setText($ssScoreHudEnemyScore);
}

function ssScoreHudHandleJoin(%msgType, %msgString, %clientName, %clientId) {
    if (strStr(%msgString, "Welcome to Tribes") != -1) {
        SSScoreHudCarrierName.setVisible(0);
        SSScoreHudCarrierHealth.setVisible(0);
        SSFriendlyScoreHudText.setVisible(1);
        SSEnemyScoreHudText.setVisible(1);
        $ssScoreHudClientId = %clientId;
        $ssScoreHudTeamId = 1;
        ssScoreHudReset();
    }
}

function ssScoreHudHandleJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId) {
    if ($ssScoreHudClientId == %clientId) {
        $ssScoreHudTeamId = %teamId != 0 ? %teamId : 1;
        commandToServer('getScores');
    }
}

package ssScoreHud {
    function DispatchLaunchMode() {
        parent::DispatchLaunchMode();
        ssMakeScoreHud();
    }

    function disconnect() {
        parent::disconnect();
        ssScoreHudReset();
    }
};
activatePackage(ssScoreHud);

function ssScoreHudFriendlyTimer(%first) {
    if (%first)
        $ssScoreHudFriendlyTime = 45;
    else
        $ssScoreHudFriendlyTime -= $ssScoreHudInterval;
    %fmt = strLen(getSubStr($ssScoreHudInterval,(strStr($ssScoreHudInterval,".") == -1) ? 0 : strStr($ssScoreHudInterval,"."),1000))-1;
    SSFriendlyScoreHudText.setText("\c0\x8b\c7" @ mFormatFloat($ssScoreHudFriendlyTime,"%." @ (%fmt != -1 ? %fmt : 0) @ "f") @ "\c0\x9b");
    $ssScoreHudFriendlySchedule = schedule($ssScoreHudInterval*1000,0,ssScoreHudFriendlyTimer);
}

function ssScoreHudEnemyTimer(%first) {
    if (%first)
        $ssScoreHudEnemyTime = 45;
    else
        $ssScoreHudEnemyTime -= $ssScoreHudInterval;
    %fmt = strLen(getSubStr($ssScoreHudInterval,(strStr($ssScoreHudInterval,".") == -1) ? 0 : strStr($ssScoreHudInterval,"."),1000))-1;
    SSEnemyScoreHudText.setText("\c0\x8b\c7" @ mFormatFloat($ssScoreHudEnemyTime,"%." @ (%fmt != -1 ? %fmt : 0) @ "f") @ "\c0\x9b");
    $ssScoreHudEnemySchedule = schedule($ssScoreHudInterval*1000,0,ssScoreHudEnemyTimer);
}

function ssScoreHudReset() {
    SSFriendlyScoreHudText.setText("Home");
    if (isEventPending($ssScoreHudFriendlySchedule))
        cancel($ssScoreHudFriendlySchedule);
    SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
    SSEnemyScoreHudText.setText("Home");
    if (isEventPending($ssScoreHudEnemySchedule))
        cancel($ssScoreHudEnemySchedule);
    SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
    SSScoreHudCarrierName.setText("Center");
}

function ssScoreHudHandleTR2HudInit(%msgType, %msgString, %team1, %team2, %score1, %score2, %flagLoc, %carrierHealth) {
    SSScoreHudCarrierName.setVisible(1);
    SSScoreHudCarrierHealth.setVisible(1);
    SSFriendlyScoreHudText.setVisible(0);
    SSEnemyScoreHudText.setVisible(0);
    $ssScoreHudFriendlyScore = ($ssScoreHudTeamId == 1) ? detag(%score1) : detag(%score2);
    $ssScoreHudEnemyScore = ($ssScoreHudTeamId == 1) ? detag(%score2) : detag(%score1);
    SSScoreHudCarrierName.setText(%flagLoc);
    SSScoreHudCarrierHealth.setValue(%carrierHealth);
    SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
    SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
    ssScoreHudDrawScores();
}

function ssScoreHudHandleTR2SetScore(%msgType, %msgString, %team, %score) {
    if ($ssScoreHudTeamId == %team)
        $ssScoreHudFriendlyScore = %score;
    else
        $ssScoreHudEnemyScore = %score;
    ssScoreHudDrawScores();
}

function ssScoreHudHandleTR2FlagStatus(%msgType, %msgString, %location) {
    SSScoreHudCarrierName.setText(detag(%location));
}

function ssScoreHudHandleTR2FlagTaken(%msgType, %msgString, %client, %team, %flagteam, %clientnamebase) {
    SSScoreHudCarrierName.setText(detag(%client));
}

function ssScoreHudHandleTR2FlagDropped(%msgType, %msgString, %client, %team, %flagteam) {
    SSScoreHudCarrierName.setText("Dropped");
    SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
    SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
}

function ssScoreHudHandleTR2CarrierHealth(%msgType, %msgString, %amt, %team) {
    if (%team == 1) {
        SSScoreHudCarrierHealth.profile.fillColor = $TR2::Color::CarrierFriendly;
        SSFriendlyScoreHud.setBitmap("ssflag_friendly_taken.png");
    } else {
        SSScoreHudCarrierHealth.profile.fillColor = $TR2::Color::CarrierEnemy;
        SSEnemyScoreHud.setBitmap("ssflag_enemy_taken.png");
    }
    SSScoreHudCarrierHealth.setValue(%amt);
}

function ssMakeScoreHud() {
    new GuiControlProfile(SSScoreHudTextProfile) {
        fontType = "Univers";
        fontSize = 12;
        fontColor = $PlayerNameColor;
        fontColors[6] = $PlayerNameColor;
        fontColors[7] = $TribeTagColor;
        fontColors[8] = $SmurfNameColor;
        fontColors[9] = $BotNameColor;
        justify = "left";
    };
    
    new GuiControlProfile(SSScoreHudCarrierNameProfile) {
        fontType = "Univers";
        fontSize = 12;
        fontColor = $PlayerNameColor;
        fontColors[6] = $PlayerNameColor;
        fontColors[7] = $TribeTagColor;
        fontColors[8] = $SmurfNameColor;
        fontColors[9] = $BotNameColor;
        justify = "left";
    };

    new GuiControlProfile(SSScoreHudScoreProfile) {
        fontType = "Univers";
        fontSize = 12;
        fontColor = $PlayerNameColor;
        justify = "center";
    };
    
    new GuiControl(SSFriendlyScoreHudFrame) {
        profile = "GuiDefaultProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "0 0";
        extent = "200 12";
        minExtent = "8 8";
        visible = "1";

        new HudBitmapCtrl(SSFriendlyScoreHud) {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "20 0";
            extent = "15 12";
            minExtent = "8 8";
            visible = "1";
            opacity = "0.5";
            bitmap = "ssflag_friendly.png";
            autoResize = "1";

        };
        new GuiTextCtrl(SSFriendlyScoreHudText) {
            profile = "SSScoreHudTextProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "38 0";
            extent = "162 12";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
        };
        new GuiTextCtrl(SSFriendlyScoreHudScore) {
            profile = "SSScoreHudScoreProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "0 0";
            extent = "20 12";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
        };
        new GuiTextCtrl(SSScoreHudCarrierName) {
            profile = "SSScoreHudCarrierNameProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "38 0";
            extent = "177 12";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
            text = "Center";
        };
    };

    new GuiControl(SSEnemyScoreHudFrame) {
        profile = "GuiDefaultProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "0 0";
        extent = "207 12";
        minExtent = "8 8";
        visible = "1";

        new HudBitmapCtrl(SSEnemyScoreHud) {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "20 0";
            extent = "15 12";
            minExtent = "8 8";
            visible = "1";
            opacity = "0.5";
            bitmap = "ssflag_enemy.png";
            autoResize = "1";
        };
        new GuiTextCtrl(SSEnemyScoreHudText) {
            profile = "SSScoreHudTextProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "38 0";
            extent = "162 12";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
        };
        new GuiTextCtrl(SSEnemyScoreHudScore) {
            profile = "SSScoreHudScoreProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "0 0";
            extent = "20 12";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
        };
        new GuiProgressCtrl(SSScoreHudCarrierHealth) {
            profile = "TR2CarrierHealth";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "38 3";
            extent = "93 10";
            minExtent = "8 8";
            visible = "0";
            hideCursor = "0";
            bypassHideCursor = "0";
            helpTag = "0";
        };
    };
    playGui.add(SSFriendlyScoreHudFrame);
    playGui.add(SSEnemyScoreHudFrame);
    if (isObject(HM) && isObject(HudMover)) {
        hudmover::addhud(SSFriendlyScoreHudFrame, "Friendly Score/Flag");
        hudmover::addhud(SSEnemyScoreHudFrame, "Enemy Score/Flag");
    }
    addMessageCallback('MsgCTFFlagTaken', ssScoreHudHandleFlag);
    addMessageCallback('MsgCTFFlagDropped', ssScoreHudHandleFlag);
    addMessageCallback('MsgCTFFlagReturned', ssScoreHudHandleFlag);
    addMessageCallback('MsgCTFFlagCapped', ssScoreHudHandleFlag);
    addMessageCallback('MsgTeamScore', ssScoreHudHandleScore);
    addMessageCallback('MsgGameOver', ssScoreHudReset);
    addMessageCallback('MsgClientJoin', ssScoreHudHandleJoin);
    addMessageCallback('MsgClientJoinTeam', ssScoreHudHandleJoinTeam);
    addMessageCallback('MsgTR2ObjInit', ssScoreHudHandleTR2HudInit);
    addMessageCallback('MsgTR2SetScore', ssScoreHudHandleTR2SetScore);
    addMessageCallback('MsgTR2FlagStatus', ssScoreHudHandleTR2FlagStatus);
    addMessageCallback('MsgTR2FlagTaken', ssScoreHudHandleTR2FlagTaken);
    addMessageCallback('MsgTR2FlagDropped', ssScoreHudHandleTR2FlagDropped);
    addMessageCallback('MsgTR2CarrierHealth', ssScoreHudHandleTR2CarrierHealth);
}
